"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _react = _interopRequireDefault(require("react"));
var _testUtils = require("testUtils");
var _immutable = _interopRequireDefault(require("immutable"));
var _data_utils = require("../../../utils/data_utils");
var i18n = _interopRequireWildcard(require("../../../i18n"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var _dataFns = (0, _data_utils.dataFns)(['i18n']),
  set = _dataFns.set;
jest.mock('engine/classic');
jest.mock('connection/enterprise/hrd_pane', function () {
  return (0, _testUtils.mockComponent)('hrd_pane');
});
jest.mock('connection/enterprise', function () {
  return {
    enterpriseDomain: jest.fn(function () {
      return 'domain.com';
    })
  };
});
var getComponent = function getComponent() {
  var HRDScreen = require('connection/enterprise/hrd_screen').default;
  var screen = new HRDScreen();
  return screen.render();
};
describe('HRDScreen Component', function () {
  var i18nProp;
  var lock;
  beforeEach(function () {
    lock = _immutable.default.fromJS({
      id: '__lock-id__'
    });
    jest.resetModules();
    var lang = _immutable.default.fromJS({
      enterpriseLoginIntructions: 'Login with your corporate credentials.',
      enterpriseActiveLoginInstructions: 'Please enter your corporate credentials at %s.'
    });
    lock = set(lock, 'strings', lang);
    i18nProp = {
      str: function str(keypath) {
        for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }
        return i18n.str(lock, keypath, args);
      }
    };
  });
  it('renders correctly when there is an enterprise domain', function () {
    var Component = getComponent();
    (0, _testUtils.expectComponent)( /*#__PURE__*/_react.default.createElement(Component, {
      model: lock,
      i18n: i18nProp
    })).toMatchSnapshot();
  });
  it('renders correctly when there is no enterprise domain', function () {
    require('connection/enterprise').enterpriseDomain.mockImplementation(function () {
      return null;
    });
    var Component = getComponent();
    (0, _testUtils.expectComponent)( /*#__PURE__*/_react.default.createElement(Component, {
      model: lock,
      i18n: i18nProp
    })).toMatchSnapshot();
  });
});
