"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _react = _interopRequireDefault(require("react"));
var _testUtils = require("testUtils");
var _immutable = _interopRequireDefault(require("immutable"));
var _field = require("../../../field");
var i18n = _interopRequireWildcard(require("../../../i18n"));
var _testUtils2 = require("../../testUtils");
var _data_utils = require("../../../utils/data_utils");
var _phone_number = require("../../../field/phone_number");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var _dataFns = (0, _data_utils.dataFns)(['i18n']),
  set = _dataFns.set;
jest.mock('engine/classic');
jest.mock('field/vcode/vcode_pane', function () {
  return (0, _testUtils.mockComponent)('vcode_pane');
});
jest.mock('field/phone-number/locations', function () {
  return {
    __esModule: true,
    default: [['United Kingdom', 'UK', '+44']]
  };
});
jest.mock('connection/passwordless/index', function () {
  return {
    isEmail: jest.fn()
  };
});
var getComponent = function getComponent() {
  var VCodeScreen = require('connection/passwordless/ask_vcode').default;
  var screen = new VCodeScreen();
  return screen.render();
};
describe('AskVCode', function () {
  var lock;
  var i18nProp;
  beforeEach(function () {
    lock = _immutable.default.fromJS({
      id: '__lock-id__'
    });
    jest.resetModules();
    var lang = _immutable.default.fromJS({
      passwordlessEmailCodeInstructions: 'An email with the code has been sent to %s.',
      passwordlessSMSCodeInstructions: 'An SMS with the code has been sent to %s.'
    });
    lock = set(lock, 'strings', lang);
    i18nProp = {
      str: function str(keypath) {
        for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }
        return i18n.str(lock, keypath, args);
      }
    };
  });
  it('renders correctly when logging in with email', function () {
    require('connection/passwordless/index').isEmail.mockImplementation(function () {
      return true;
    });
    var Component = getComponent();
    var l = (0, _field.setField)(lock, 'email', 'test@user.com');
    (0, _testUtils2.expectComponent)( /*#__PURE__*/_react.default.createElement(Component, {
      model: l,
      i18n: i18nProp
    })).toMatchSnapshot();
  });
  it('renders correctly when logging in with a phone number', function () {
    require('connection/passwordless/index').isEmail.mockImplementation(function () {
      return false;
    });
    var Component = getComponent();
    var l = (0, _phone_number.setPhoneNumber)(lock, '456 789');
    l = (0, _phone_number.initLocation)(l, 'UK');
    (0, _testUtils2.expectComponent)( /*#__PURE__*/_react.default.createElement(Component, {
      model: l,
      i18n: i18nProp
    })).toMatchSnapshot();
  });
});
